      SUBROUTINE REL(ERRMAX,DELTA,YIC,N)
C
C This subroutine is used in the variable step size Runge-Kutta
C integration of the fundamental solutions in the inner core.
C It finds the maximum relative error in the elements of
C the difference array, DELTA(6,3), compared to the elements of
C the fundamental solution array, YIC(6,3),for degree N.
C
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DIMENSION DELTA(6,3),YIC(6,3)
C Zero relative error.
      ERRMAX=0.D0
      DO 10 I=1,6
C Branch for degee zero.
        IF(N.EQ.0)GO TO 11
        GO TO 12
C If degree is zero skip y3 and y4.
 11     IF(I.EQ.3.OR.I.EQ.4)GO TO 10
 12     DO 13 J=1,3
C Third solution is only fundamental solution for degree zero.
          IF(N.EQ.0.AND.J.NE.3)GO TO 13
          IF(YIC(I,J).EQ.0.D0)GO TO 13
          RATIO=DABS(DELTA(I,J)/YIC(I,J))
          ERRMAX=DMAX1(ERRMAX,RATIO)
 13     CONTINUE
 10   CONTINUE
      RETURN
      END  
