      SUBROUTINE WINDOW(T,T0,AM,W)
C
C WINDOW finds the value of the PARZEN window, W, at time T,
C for a window of length AM centred at time T0.
C 
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
C Find relative time on (-1,1) time base.
      X=2.D0*(T-T0)/AM
C Find unity minus absolute value of relative time.
      OMX=1.D0-DABS(X)
C If absolute value of relative time is greater than 0.5,
C select alternate cubic.
      IF(DABS(X).GT.0.5D0) GO TO 10
      W=1.D0-6.D0*OMX*X*X
      GO TO 20
 10   W=2.D0*OMX*OMX*OMX
 20   CONTINUE   
      RETURN
      END
